; Expanding effect from Unfolding (64bytes) towards more designed prod.
; Attempt was to create a creepy organic life-form with "under water feeling".
; Sound is using 2 channels with slightly moved frequency for this nice buzzing notes
; Extra layer using sprites is added to improve impression of under-water depth.
; The font in the charset is a part of the ROM memory, where interesting looking pattern was present.
RANDOM	equ $d20a
WSYNC	equ $D40a
VCOUNT	equ $D40B

TIMER2  equ $14
TIMER1  equ $13
;;;;;; SOUND 
AUDF1	equ $D200
AUDF3	equ $D204
AUDC1	equ $D201
AUDC3	equ $D205
AUDCTL	equ $D208


;;;;;; GFX
GPRIOR  equ $026F

ROWCRS	equ $54		;Row of cursor, 1 byte
COLCRS	equ $55		;Column of cursor, 2 bytes

OLDROW  equ $5A
OLDCOL  equ $5B     ; 2 bytes
ADRESS equ $64

SUBSTRACT equ $F581
SUBTMP EQU $029E

HPOSM1 = $D005 ; Missile 1 Horizontal Position
PCOLR1 = $02C1
GRAFM =  $D011 ; Missile Graphics Pattern (2 bits per missile)

CHBAS equ $2F4          	
; Aliases, because orig reg names are hard to remember ;)
cursor_y    equ ROWCRS
cursor_x    equ COLCRS
prev_y      equ OLDROW
prev_x      equ OLDCOL

; OS functions
openmode  equ $ef9c
drawpoint equ $f1d8
drawto    equ $f9c2
putline   equ $c642
print     equ $f1a4


PMG_POS equ $5000
sine equ $80
temp equ sine-1
;	org $2000
	org $2000			
start:
	
.local init_sine
	 lda #$FD ; more like plasma
	 tay
	 ldx #128+64 ; #63	 
	 
LOOP1
	 dey
LOOP2
	 sta sine-1,x
	 sta GPRIOR-3,x
	 dex 
	 beq exit
	 sty temp
	 adc temp 
	 bmi LOOP1
	 iny
	 jmp LOOP2
EXIT:
.endl

; A = 35
; X = 00
; Y = 0B

; init sound
;	lda #1
;	sta SKCTL ; no space for proper initalization :-(

	lda #7 ; or 15 - high pass filter on channel 1
	sta GRAFM	
	sta AUDCTL
	
	lda #$cd
	sta PCOLR1

	lda #168
	sta AUDC1
	sta AUDC3
	
NEXT_FRAME:

.local sound
	lda TIMER1
	and #3
	tay
	lda notes,y
	sta AUDF3
	sbc #1
	sta AUDF1	
.endl
	; x=0
	dex
	stx ADRESS 
	lda #$BF
	sta ADRESS+1 

	ldx #23 ; row
NEXT_ROW:
	ldy #40 ; column
	sty SUBTMP
	jsr substract
ROW_LOOP:

.local pmg
	stx temp
	ldx VCOUNT
	lda RANDOM
	and #3
	bne skip
	inc PMG_POS,x
skip	
	lda PMG_POS,x
	sta HPOSM1
	ldx temp
.endl
	lda TIMER2
	adc sine,y
	adc sine,x
	sta (adress),y
	dey
	bne ROW_LOOP		
	dex	
	bpl NEXT_ROW		
	bmi NEXT_FRAME
notes:
	.byte 250, 200, 238, 178
;	RUN start